#define USE_DEFAULT_VERT
#include "../../base.shader"

sampler2D _texture;
float4 _color;
PIX_OUTPUT pix(in PIX_INPUT input) : COLOR0
{
	float4 pixel = tex2D(_texture, input.uv);
	if(pixel.g > pixel.r && abs(pixel.r - pixel.b) < .025) // Replace green pixels with allegiance color.
	{
		float3 scaledAllegianceColor = input.color.rgb * pixel.g;
		float desaturation = pixel.r / pixel.g; // works because pixel.r == pixel.b (approximately)
		float desaturationValue = max(scaledAllegianceColor.r, max(scaledAllegianceColor.g, scaledAllegianceColor.b));
		float3 desaturationColor = float3(desaturationValue, desaturationValue, desaturationValue);
		pixel.rgb = scaledAllegianceColor * (1 - desaturation) + desaturationColor * desaturation;
	}
	
	pixel.a *= input.color.a;
	return pixel * _color;
}
